//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.5-b10 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2013.03.01 at 11:27:27 AM EST 
//


package org.omg.uml;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for PseudostateKind.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p>
 * <pre>
 * &lt;simpleType name="PseudostateKind">
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *     &lt;enumeration value="initial"/>
 *     &lt;enumeration value="deepHistory"/>
 *     &lt;enumeration value="shallowHistory"/>
 *     &lt;enumeration value="join"/>
 *     &lt;enumeration value="fork"/>
 *     &lt;enumeration value="junction"/>
 *     &lt;enumeration value="choice"/>
 *     &lt;enumeration value="entryPoint"/>
 *     &lt;enumeration value="exitPoint"/>
 *     &lt;enumeration value="terminate"/>
 *   &lt;/restriction>
 * &lt;/simpleType>
 * </pre>
 * 
 */
@XmlType(name = "PseudostateKind")
@XmlEnum
public enum PseudostateKind {


    /**
     * An initial pseudostate represents a default vertex that is the source for a single transition to the default state of a composite state. There can be at most one initial vertex in a region. The outgoing transition from the initial vertex may have a behavior, but not a trigger or guard.
     * 
     */
    @XmlEnumValue("initial")
    INITIAL("initial"),

    /**
     * DeepHistory represents the most recent active configuration of the composite state that directly contains this pseudostate; e.g. the state configuration that was active when the composite state was last exited. A composite state can have at most one deep history vertex. At most one transition may originate from the history connector to the default deep history state. This transition is taken in case the composite state had never been active before. Entry actions of states entered on the path to the state represented by a deep history are performed.
     * 
     */
    @XmlEnumValue("deepHistory")
    DEEP_HISTORY("deepHistory"),

    /**
     * ShallowHistory represents the most recent active substate of its containing state (but not the substates of that substate). A composite state can have at most one shallow history vertex. A transition coming into the shallow history vertex is equivalent to a transition coming into the most recent active substate of a state. At most one transition may originate from the history connector to the default shallow history state. This transition is taken in case the composite state had never been active before. Entry actions of states entered on the path to the state represented by a shallow history are performed.
     * 
     */
    @XmlEnumValue("shallowHistory")
    SHALLOW_HISTORY("shallowHistory"),

    /**
     * Join vertices serve to merge several transitions emanating from source vertices in different orthogonal regions. The transitions entering a join vertex cannot have guards or triggers.
     * 
     */
    @XmlEnumValue("join")
    JOIN("join"),

    /**
     * Fork vertices serve to split an incoming transition into two or more transitions terminating on orthogonal target vertices (i.e. vertices in different regions of a composite state). The segments outgoing from a fork vertex must not have guards or triggers.
     * 
     */
    @XmlEnumValue("fork")
    FORK("fork"),

    /**
     * Junction vertices are semantic-free vertices that are used to chain together multiple transitions. They are used to construct compound transition paths between states. For example, a junction can be used to converge multiple incoming transitions into a single outgoing transition representing a shared transition path (this is known as an merge). Conversely, they can be used to split an incoming transition into multiple outgoing transition segments with different guard conditions. This realizes a static conditional branch. (In the latter case, outgoing transitions whose guard conditions evaluate to false are disabled. A predefined guard denoted 'else' may be defined for at most one outgoing transition. This transition is enabled if all the guards labeling the other transitions are false.) Static conditional branches are distinct from dynamic conditional branches that are realized by choice vertices (described below).
     * 
     */
    @XmlEnumValue("junction")
    JUNCTION("junction"),

    /**
     * Choice vertices which, when reached, result in the dynamic evaluation of the guards of the triggers of its outgoing transitions. This realizes a dynamic conditional branch. It allows splitting of transitions into multiple outgoing paths such that the decision on which path to take may be a function of the results of prior actions performed in the same run-tocompletion step. If more than one of the guards evaluates to true, an arbitrary one is selected. If none of the guards evaluates to true, then the model is considered ill-formed. (To avoid this, it is recommended to define one outgoing transition with the predefined else guard for every choice vertex.) Choice vertices should be distinguished from static branch points that are based on junction points (described above).
     * 
     */
    @XmlEnumValue("choice")
    CHOICE("choice"),

    /**
     * An entry point pseudostate is an entry point of a state machine or composite state. In each region of the state machine or composite state it has a single transition to a vertex within the same region.
     * 
     */
    @XmlEnumValue("entryPoint")
    ENTRY_POINT("entryPoint"),

    /**
     * An exit point pseudostate is an exit point of a state machine or composite state. Entering an exit point within any region of the composite state or state machine referenced by a submachine state implies the exit of this composite state or submachine state and the triggering of the transition that has this exit point as source in the state machine enclosing the submachine or composite state.
     * 
     */
    @XmlEnumValue("exitPoint")
    EXIT_POINT("exitPoint"),

    /**
     * Entering a terminate pseudostate implies that the execution of this state machine by means of its context object is terminated. The state machine does not exit any states nor does it perform any exit actions other than those associated with the transition leading to the terminate pseudostate. Entering a terminate pseudostate is equivalent to invoking a DestroyObjectAction.
     * 
     */
    @XmlEnumValue("terminate")
    TERMINATE("terminate");
    private final String value;

    PseudostateKind(String v) {
        value = v;
    }

    public String value() {
        return value;
    }

    public static PseudostateKind fromValue(String v) {
        for (PseudostateKind c: PseudostateKind.values()) {
            if (c.value.equals(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

}
